/*******************************************************************************
 * linked_list
 *
 * A simple doubly linked list class in C.
 *
 * Not thread safe.
 *
 * Since this class does not attempt to manage memory for the actual stored 
 * objects, there is no "clear" method to delete the entire list.  Instead,
 * the user must pop the entire list and delete the individually returned
 * objects one at a time.
 *
 * A potential improvement would be to allow the registration of an object
 * destructor at list creation which could then be used by a clear() method.
 *
 *
 *
 *
 * OOH SHINY!
 * http://tinobox.com/wordpress/object-oriented-c-coding/
 *
 * Looks liks good stuff.  Must read.
 *
 ******************************************************************************/

#ifndef LINKEDLIST_H
#define LINKEDLIST_H

typedef struct ll_node ll_node;

typedef struct LinkedList LinkedList;
struct LinkedList
   {
   /* Public */
   void *       (* push)  (LinkedList * this, void * data);
   void *       (* pop)   (LinkedList * this);
   void *       (* insert)(LinkedList * this, void * data);
   void *	(* remove)(LinkedList * this);
   void *       (* insert_at_head)(LinkedList * this, void * data);
   int		(* size)  (LinkedList * this);
   void	*	(* head)  (LinkedList * this);
   void	*	(* tail)  (LinkedList * this);
   void	*	(* next)  (LinkedList * this);
   void	*	(* prev)  (LinkedList * this);
   void *	(* data)  (LinkedList * this);

   /* Private (notionally, at least) */
   ll_node *	Head;
   ll_node *	Curr;
   ll_node *	Tail;
   int		Size;
   };

#endif

